Subject: Re: bug#55231: [PATCH v1] initrd: Allow extra search paths with ‘initrd-extra-module-paths’

From: "Leo Famulari" <[email-masked]>
Date: Sun, 16 Feb 2025 15:19:07 -0500

On Sun, Feb 16, 2025, at 13:25, Morgan Arnold wrote:
> As you note, the only person who would distribute such a pre-compiled 
> initrd would be someone who built one and shared it, say with `guix 
> publish`. A lot of the discussion essentially boils down to one 
> question: is Guix responsible only for not committing copyright 
> violations itself, say by not distributing such a pre-compiled initrd 
> itself, or is Guix also responsible for putting in guardrails to 
> prevent users from accidentally committing copyright violations? If you 
> subscribe to the former view, then the original changes proposed by 
> Brian are entirely acceptable as is. If, instead, you subscribe to the 
> latter view, then this change may be unacceptable, as it facilitates 
> the accidental commission of copyright violations by users of Guix. The 
> changes made here to derivations are an attempt to allow users to 
> create ZFS-compatible initrds in a manner which is compatible with the 
> latter (more conservative, in some sense) view of the responsibilities 
> of Guix.

Thanks for your work writing this summary, Morgan.

I think the latter point of view, the "conservative" view, actually represents a somewhat radical break from how the Guix project has organized itself thus far. We've always focused on the GNU "freedom zero": the freedom to use the software as one sees fit.

https://www.gnu.org/philosophy/free-sw.en.html#four-freedoms

If we start hard-coding restrictions on how users can use Guix and the free software it provides, we are turning our back on that value.

Second, I think the discussion here is being clouded by the fact that ZFS is a cause célèbre in the world of copyleft licensing.

It's the same as if someone linked OpenSSL 1.0 with a GPL program for their own use. That was a useful thing to create, but the old OpenSSL license did not permit redistribution. Although Guix tried avoid creating these combinations in our packages, we would have never sought to prevent users from doing so.

To build on that scenario, I could link ZFS with Linux, build it on my offload server, and use it on the servers I control. That is, I'd be substituting it. But I would not be distributing it to a 3rd party, so the copyright licenses would not apply.

Leo